package model.group;

import java.util.Map;
import model.generic.PropertyItem;
import java.util.HashMap;

public class GroupReposirory extends PropertyItem{
    private Map<String, Group> groups;
	private byte currentGroupId = 1;

	public GroupReposirory() {
		this.groups = new HashMap<>();
	}

	public void addGroup(Group group) {
		if(this.groups.containsKey(group.getName())) {
			throw new IllegalArgumentException("Es existiert bereits eine Gruppe mit diesem Namen");
		}
		group.setId(currentGroupId);
		currentGroupId++;
		this.groups.put(group.getName(), group);
		this.propertySupport.firePropertyChange("groups", null, group);
	}
	
	public Group getGroup(String name) {
		return groups.get(name);
	}
	
	public void removeGroup(String name) {
		this.groups.get(name).deactivate();
		this.propertySupport.firePropertyChange("groups", this.groups.get(name), null);
		this.groups.remove(name);
	}
	
	public Map<String, Group> getGroupsMap() {
		return this.groups;
	}
	
	public void clearRepro() {
		Map.copyOf(this.groups).forEach((String name, Group group) -> {
			this.removeGroup(name);
		});
		this.currentGroupId = 0;
	}
}
