package model.lightController.artNet.artNetNode;

import java.util.concurrent.atomic.AtomicBoolean;

import model.generic.PropertyItem;

public class ArtNetNode extends PropertyItem{
	private String name;
    private String ip;
    private int port;
    private byte net;
    private byte subNet;
    private byte universe;
    private AtomicBoolean connected = new AtomicBoolean(false);

    public ArtNetNode(String name, String ip, int port) {
    	super();
    	this.name = name;
    	this.ip = ip;
        this.port = port;
        this.net = (byte)0x00;
		this.subNet = (byte)0x00;
		this.universe = (byte)0x00;
    }

	public ArtNetNode(String name, String ip, int port, byte net, byte subNet, byte universe) {
		super();
		this.name = name;
		this.ip = ip;
		this.port = port;
		this.net = net;
		this.subNet = subNet;
		this.universe = universe;
	}
	
	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.propertySupport.firePropertyChange("name", this.name, name);
		this.name = name;
	}

	public String getIp() {
		return ip;
	}

	public void setIp(String ip) {
		this.propertySupport.firePropertyChange("ip", this.ip, ip);
		this.ip = ip;
	}

	public int getPort() {
		return port;
	}

	public void setPort(int port) {
		this.propertySupport.firePropertyChange("port", this.port, port);
		this.port = port;
	}

	public byte getNet() {
		return net;
	}

	public void setNet(byte net) {
		this.propertySupport.firePropertyChange("net", this.net, net);
		this.net = net;
	}

	public byte getSubNet() {
		return subNet;
	}

	public void setSubNet(byte subNet) {
		this.propertySupport.firePropertyChange("subNet", this.subNet, subNet);
		this.subNet = subNet;
	}

	public byte getUniverse() {
		return universe;
	}

	public void setUniverse(byte universe) {
		this.propertySupport.firePropertyChange("universe", this.universe, universe);
		this.universe = universe;
	}
	
	public boolean isConnected() {
		return this.connected.get();
	}
	
	public void setConnectStatus(boolean status) {
		this.propertySupport.firePropertyChange("connected", this.connected, status);
		this.connected.set(status);
	}
}
