package model.lightController.artNet.artNetPakages;

import java.nio.ByteBuffer;

public class ArtPoll {
    private String id = "Art-Net" + (char)0x00;
    private short opCode = ArtNetCodeLibrary.OpCodes.OP_POLL.opCode;
    private byte protVerHi = 0x00;
    private byte protVerLo = 0x0E; // Version 14
    private byte flags = 0x00;
    private byte diagPriority = 0x00;
    private byte targetPortAddressTopHi = 0x00;
    private byte targetPortAddressTopLo = 0x00;
    private byte targetPortAddressBottomHi = 0x00;
    private byte targetPortAddressBottomLo = 0x00;
    private byte estaManHi = 0x00;
    private byte estaManLo = 0x00;
    private byte oemHi = (byte)0xff;
    private byte oemLo = (byte)0xff;

    public ArtPoll() {}

    public byte[] getUdpArray() {
        byte[] udpArray = new byte[22];
        byte[] opCodeArray = ByteBuffer.allocate(2).putShort(this.opCode).array();

        // id
        for(int i = 0; i < 8; i++) {
            udpArray[i] = (byte)this.id.charAt(i);
        }

        // op code
        udpArray[8] = opCodeArray[1];
        udpArray[9] = opCodeArray[0];

        // protocoll version
        udpArray[10] = this.protVerHi;
        udpArray[11] = this.protVerLo;

        // flag
        udpArray[12] = this.flags;

        // diagonstic prio
        udpArray[13] = this.diagPriority;

        // target port
        udpArray[14] = this.targetPortAddressTopHi;
        udpArray[15] = this.targetPortAddressTopLo;
        udpArray[16] = this.targetPortAddressBottomHi;
        udpArray[17] = this.targetPortAddressBottomLo;

        // esta manifacture
        udpArray[18] = this.estaManHi;
        udpArray[19] = this.estaManLo;

        // oem
        udpArray[20] = this.oemHi;
        udpArray[21] = this.oemLo;

        return udpArray;
    }
}
