package model.lightingScene.lightingMood;

import model.fixture.DmxValues;
import model.generic.PropertyItem;
import model.lightingScene.LightingScene;

public class LightingMood extends PropertyItem implements LightingScene{
    private String name;
	private boolean isActive;
    private DmxValues dmxValues;
	
	public LightingMood(String name) {
		super();
		this.name = name;
		this.isActive = false;
        this.dmxValues = new DmxValues();
	}

	public String getName() {
		return name;
	}

    public void setName(String name) {
		propertySupport.firePropertyChange("name", this.name, name);
		this.name = name;
	}
	
	public boolean isActive() {
		return this.isActive;
	}

	public DmxValues getDmxValues() {
		return this.dmxValues;
	}
	
	public void setDmxValues(DmxValues dmxValues) {
        propertySupport.firePropertyChange("dmxValues", this.dmxValues, dmxValues);
		this.dmxValues = dmxValues;
	}
	
	@Override
	public void activate() {
		if(!this.isActive) {
			this.isActive = true;
			propertySupport.firePropertyChange("isActive", false, true);
		}
		
		
	}
	
	@Override
	public void deactivate() {
		this.isActive = false;
		propertySupport.firePropertyChange("isActive", true, false);
	}
	
	public LightingSceneType getLightingSceneType() {
		return LightingSceneType.LIGHTING_MOOD;
	}
}
