package model.lightingScene.lightingMood;


import java.util.Map;

import model.generic.PropertyItem;

import java.util.HashMap;

public class LightingMoodRepository extends PropertyItem {
    private Map<String, LightingMood> lightingMoods;

    public LightingMoodRepository() {
        this.lightingMoods = new HashMap<>();
    }

    public void addLightingMood(LightingMood lightingMood) {
    	if(this.lightingMoods.containsKey(lightingMood.getName())) {
			throw new IllegalArgumentException("Es existiert bereits eine Lichtstimmung mit diesem Namen");
		}
    	
    	this.lightingMoods.put(lightingMood.getName(), lightingMood);
		this.propertySupport.firePropertyChange("lightingMoods", null, lightingMood);
	}
	
	public LightingMood getLightingMood(String name) {
		return lightingMoods.get(name);
	}
	
	public void removeLightingMood(String name) {
		this.propertySupport.firePropertyChange("lightingMoods", this.lightingMoods.get(name), null);
		this.lightingMoods.remove(name);
	}
	
	public Map<String, LightingMood> getLightingMoodMap() {
		return this.lightingMoods;
	}
}