package view;

import javafx.application.Platform;
import javafx.fxml.FXMLLoader;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.image.Image;
import javafx.stage.Stage;
import view.mainScene.MainSceneController;
import viewModel.KiwiViewModelHandler;

public class KiwiViewHandler{
    
	private Stage stage;
	private KiwiViewModelHandler viewModelHandler;
	
	public KiwiViewHandler(Stage stage, KiwiViewModelHandler viewModelHandler) {
		this.stage = stage;
		this.viewModelHandler = viewModelHandler;
	}
	
	public void start() throws Exception {
		FXMLLoader loader = new FXMLLoader(getClass().getResource("mainScene/MainScene.fxml"));
		Parent root;
		root = loader.load();
		MainSceneController mainSceneController= loader.getController();
		mainSceneController.init(viewModelHandler);
		Scene scene = new Scene(root);
		scene.getStylesheets().add("style/Style.css");
		this.stage.setMinWidth(800);
		this.stage.setMinHeight(625);
		this.stage.setTitle("KIWI Illumination Weeny Interface");
		this.stage.getIcons().add(new Image("images/Kiwi_Logo.png"));
		this.stage.setScene(scene);
		this.stage.show();
		
		this.stage.setOnCloseRequest(event -> {
			Platform.exit();
		});
	}
}
