package view.lightController.mainPanel;

import javafx.application.Platform;
import javafx.fxml.FXML;
import javafx.scene.control.Label;
import view.elements.ThreeStageButtonCallBack;
import view.elements.ThreeStageSwitchButton;
import viewModel.lightController.ArtNetControlleVM;

public class LightControllerMainPanelController implements ThreeStageButtonCallBack {
	@FXML
	private Label labelInterfaceConnection;
	
	@FXML
	private ThreeStageSwitchButton connectSwitch;
	
	private ArtNetControlleVM artNetControlleVM;
	
	public void init(ArtNetControlleVM artNetControlleVM) {
		this.artNetControlleVM = artNetControlleVM;
		this.connectSwitch.setCallback(this);
		this.artNetControlleVM.getArtNetNodeRepositoryVM().connectStateProperty().bindBidirectional(this.connectSwitch.buttonStateProperty());
		this.connectSwitch.buttonStateProperty().addListener((object, oldValue, newValue) -> {
			switch(newValue) {
				case ON:
					Platform.runLater(() -> {
						this.labelInterfaceConnection.setText("Verbunden");
					});
					break;
				case OFF:
					Platform.runLater(() -> {
						this.labelInterfaceConnection.setText("Nicht verbunden");
					});
					break;
				default:
					break;
			}
		});
	}

	@Override
	public void callClicked() {
		switch(this.connectSwitch.buttonStateProperty().get()) {
			case OFF:
				if(this.labelInterfaceConnection.getText().equals("Verbindung wird hergestellt...")) {
					this.labelInterfaceConnection.setText("Verbindung wird beendet");
					this.artNetControlleVM.disconnectFromNodes();
				} else {
					this.labelInterfaceConnection.setText("Verbindung wird hergestellt...");
					this.artNetControlleVM.connectToNodes();
				}
				break;
			case MID:
				this.labelInterfaceConnection.setText("Verbindung wird beendet");
				this.artNetControlleVM.disconnectFromNodes();
				break;
			case ON:
				this.labelInterfaceConnection.setText("Verbindung wird beendet");
				this.artNetControlleVM.disconnectFromNodes();
				break;
		}
		
	}
}
