#include "DmxController.h"

DmxController::DmxController()
{
    DmxSimple.usePin(DMX_PINOUT);
    DmxSimple.maxChannel(MAX_DMX_CHANNEL);
    activChannel = Set(true);
}

void DmxController::setChannelValue(int channel, unsigned char value)
{
    DmxSimple.write(channel, value);
}

void DmxController::setChannelValue(bool isActive, int channel, unsigned char value)
{
    this->setChannelStatus(isActive, channel);
    this->setChannelValue(channel, value);
}

void DmxController::setChannelStatus(bool isActive, int channel)
{
    if(isActive)
    {
        this->activChannel.add(channel);
    }
    else
    {
        this->activChannel.sub(channel);
    }
}

Set DmxController::getActiveChannel()
{
    return this->activChannel;
}