#ifndef Preset_h
#define Preset_h

#include <Arduino.h>
#include <EEPROM.h>
#include "set.h"
#include "../config/config.h"
#include "../PresetStoredInfromation/PresetStoredInfromation.h"
#include "../PresetLed/PresetLed.h"

class Preset:PresetStoredInfromation
{
    private:
        int eepromAdress;
        PresetLed presetLed;
        Set usedChannel;
    
    public:
        Preset();
        Preset(int eepromAdress, PresetLed presetLed);
        uint8_t getState();
        uint8_t getGroupId();
        DmxChannel* getDmxChannel();
        void setState(uint8_t state);
        void setGroupId(uint8_t groupId);
        void setChannelValue(int channel, uint8_t value);
        void clearPreset();
        void loadPresetData();
        void savePresetData();
        void updateState(Set activeChannel, bool aktiveGroupMember);
        
};
#endif