#ifndef PresetRepository_h
#define PresetRepository_h

#include "../Preset/Preset.h"
#include "../DmxController/DmxController.h"

class PresetRepository
{
    private:
        Preset presets[6];
        DmxController* dmxController;
        int eepromStartAdress;
        void sendDmxValuesOfPreset(int presetId);
        void disableOtherGroupPresets(int presetId);
        bool isGroupMemberActive(uint8_t groupId);

    public:
        PresetRepository();
        PresetRepository(int eepromStartAdress, DmxController* dmxController, int** leds);
        void activatePreset(int presetId);
        void deactivatePreset(int presetId);
        void setPresetActive(int presetId);
        void setPresetDeactiv(int presetId);
        void activateGroup(uint8_t groupId);
        void deactivateGroup(uint8_t groupId);
        void setPresetChannelValue(int presetId, int channel, uint8_t value);
        void setPresetGroupId(int presetId, uint8_t groupId);
        void clearPreset(int presetId);
        void updatePresetState();
        void updatePresetState(uint8_t groupId);
        uint8_t getPresetState(int presetId);
        Preset* getPresets();
};
#endif